'From Squeak3.7alpha of 11 September 2003 [latest update: #5595] on 14 December 2003 at 3:53:42 pm'!
"Change Set:		Chronology-a-Tests-TestRunnerOmitAbstractTestCases
Date:			03 December 2003
Author:			Brent Pinkney

This is an optional change set. It changes TestRunner to omit abstract TestCase classes"!


!TestCase methodsFor: 'Running' stamp: 'brp 12/14/2003 15:47'!
openDebuggerOnFailingTestMethod
	| guineaPig context compiledMethod debugger |
	compiledMethod _ self class lookupSelector: self selector.
	guineaPig _ [ self performTest ] newProcess.
	context _ guineaPig suspendedContext.
	debugger _ Debugger new
		process: guineaPig
		controller: ((Smalltalk isMorphic not and: [ScheduledControllers inActiveControllerProcess])
				ifTrue: [ScheduledControllers activeController]
				ifFalse: [nil])
		context: context
		isolationHead: nil.
	debugger openFullNoSuspendLabel: 'Debug failed test ', self printString.
	[debugger interruptedContext method == compiledMethod]
		whileFalse: [debugger send].
! !


!TestRunner methodsFor: 'initialize' stamp: 'brp 12/03/2003 20:02'!
gatherTestNames

	| theNames |
	theNames _ (TestCase allSubclasses select: [:e | e isAbstract not] thenCollect: [:e | e name])
					asSortedCollection.
	theNames remove: #TestViaMethodCall ifAbsent: [^ theNames].
	Smalltalk at: #TestViaMethodCall ifPresent: [ :tvmc | tvmc addClassesTo: theNames ].
	^ theNames
! !

